/**
  * @file ltc4260_regs.h
  * @author generated by mrt-device utility 
  * @link [https://mrt.readthedocs.io/en/latest/pages/mrtutils/mrt-device.html]
  * @brief values and constants for the LTC4260 device registers
  * 
  */

#define LTC4260_I2C_ADDRESS 0x88
#define LTC4260_REG_ADDR_SIZE 1
#define LTC4260_REG_COUNT 7


/*******************************************************************************
  Register Addresses                                                                              
*******************************************************************************/

#define LTC4260_REG_CONTROL_ADDR                                   0x00 /* Control Register */
#define LTC4260_REG_ALERT_ADDR                                     0x01 /* Alert Register */
#define LTC4260_REG_STATUS_ADDR                                    0x02 /* System status information */
#define LTC4260_REG_FAULT_ADDR                                     0x03 /* Fault Log */
#define LTC4260_REG_SENSE_ADDR                                     0x04 /* ADC Current Sense Voltage Data */
#define LTC4260_REG_SOURCE_ADDR                                    0x05 /* ADC Source votlage Data */
#define LTC4260_REG_ADIN_ADDR                                      0x06 /* ADC ADIN Voltage Data */


/*******************************************************************************
  Fields                                                                              
*******************************************************************************/

/* CONTROL Register Fields */
    /* CONTROL -> Flags */
    #define LTC4260_CONTROL_TEST_MODE_EN                           0x20 /* Enables Test Mode. Halts ADC operation and enables writing to ADC registers */
    #define LTC4260_CONTROL_MASS_WRITE_EN                          0x10 /* Enables writing to all devices using address b1011111 */
    #define LTC4260_CONTROL_FET_CTRL                               0x08 /* Turn FET ON */
    #define LTC4260_CONTROL_OVERCURRENT_AUTORETRY                  0x04 /* Enables automatic retry after overcurrent fault */
    #define LTC4260_CONTROL_UNDERVOLTAGE_AUTORETRY                 0x02 /* Enables automatic retry after undervoltage fault */
    #define LTC4260_CONTROL_OVERVOLTAGE_AUTORETRY                  0x01 /* Enables automatic retry after overvoltage fault */
    /* CONTROL -> GPIO_CFG */
    #define LTC4260_CONTROL_GPIO_CFG_FIELD_MASK                    0x0C /* Configures behavior of GPIO pin */
    #define LTC4260_CONTROL_GPIO_CFG_FIELD_OFFSET                  0x02
      #define LTC4260_CONTROL_GPIO_CFG_PWR_GOOD                    0x00 /* Power Good */
      #define LTC4260_CONTROL_GPIO_CFG_PWR_BAD                     0x00 /* Power Bad */
      #define LTC4260_CONTROL_GPIO_CFG_OUTPUT                      0x00 /* Output (Set by Alert:GPIO_OUT) */
      #define LTC4260_CONTROL_GPIO_CFG_INPUT                       0x00 /* Input (Read at STATUS:GPIO_IN) */
/* ALERT Register Fields */
    /* ALERT -> Flags */
    #define LTC4260_ALERT_GPIO_OUT                                 0x40 /* Output Data bit to GPIO Pin when configured as output */
    #define LTC4260_ALERT_FET_SHORT                                0x20 /* Enables Alert for FET Short condition */
    #define LTC4260_ALERT_BD_PRST_CHANGE                           0x10 /* Enables Alert when BD_PRST changes state */
    #define LTC4260_ALERT_PWR_BAD                                  0x08 /* Enables Alert when output power is bad */
    #define LTC4260_ALERT_OVERCURRENT                              0x04 /* Enables Alert when overcurrent fault occurs */
    #define LTC4260_ALERT_UNDERVOLTAGE                             0x02 /* Enables Alert when undervoltage fault occurs */
    #define LTC4260_ALERT_OVERVOLTAGE                              0x01 /* Enables Alert when overvoltage fault occurs */
/* STATUS Register Fields */
    /* STATUS -> Flags */
    #define LTC4260_STATUS_FET                                     0x80 /* Indicates state of FET */
    #define LTC4260_STATUS_GPIO_IN                                 0x40 /* State of GPIO pin when configured as input */
    #define LTC4260_STATUS_FET_SHORT                               0x20 /* Indicates Potential FET Short if Current Sense Voltage Exceeds 2mV While FET is Off */
    #define LTC4260_STATUS_BD_PRST                                 0x10 /* Indicates if Board Present is Present */
    #define LTC4260_STATUS_PWR_BAD                                 0x08 /* Indicates Power is Bad When FB is Low */
    #define LTC4260_STATUS_OVERCURRENT                             0x04 /* Indicates Overcurrent Condition During Cool Down Cycle */
    #define LTC4260_STATUS_UNDERVOLTAGE                            0x02 /* Indicates Input Undervoltage When UV is Low */
    #define LTC4260_STATUS_OVERVOLTAGE                             0x01 /* Indicates Input Overvoltage When OV is High */
/* FAULT Register Fields */
    /* FAULT -> Flags */
    #define LTC4260_FAULT_FET_SHORT                                0x20 /* Indicates Potential FET Short was Detected When Measured Current Sense Voltage Exceeded 2mV(code 0000111) While FET was Off */
    #define LTC4260_FAULT_BD_PRST_CHANGE                           0x10 /* Indicates that a Board was Inserted or Extracted When BD_PRST Changed State */
    #define LTC4260_FAULT_PWR_BAD                                  0x08 /* Indicates Power was Bad When FB Went Low (C3 = 1) */
    #define LTC4260_FAULT_OVERCURRENT                              0x04 /* Indicates Overcurrent Fault occured */
    #define LTC4260_FAULT_UNDERVOLTAGE                             0x02 /* Indicates Input Undervoltage Fault Occurred When UV Went Low */
    #define LTC4260_FAULT_OVERVOLTAGE                              0x01 /* Indicates Input Overvoltage Fault Occurred When OV Went High */

/*******************************************************************************
  Default Values                                                                              
*******************************************************************************/

#define LTC4260_CONTROL_DEFAULT                                    0x1B
#define LTC4260_ALERT_DEFAULT                                      0x00




/*******************************************************************************
  Flag Set/Clear/Check                                                                             
*******************************************************************************/

/**
  *@brief sets flags on device
  *@param dev ptr to LTC4260 device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define ltc4260_set_flag(dev, reg, mask) regdev_set_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief clears flags on device
  *@param dev ptr to LTC4260 device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define ltc4260_clear_flag(dev, reg, mask) regdev_clear_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief checks flags on device
  *@param dev ptr to LTC4260 device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  *@return true if all flags in mask are set 
  *@return false if any flags in mask are not set
  */
#define ltc4260_check_flag(dev, reg, mask) regdev_check_flags(&(dev)->mRegDev,(reg), (mask))

/*******************************************************************************
  Field Getters                                                                              
*******************************************************************************/

/**
 * @brief reads the GPIO_CFG field from the CONTROL register 
 * @param dev ptr to LTC4260 device
 * @return LTC4260_CONTROL_GPIO_CFG_PWR_GOOD Power Good
 * @return LTC4260_CONTROL_GPIO_CFG_PWR_BAD Power Bad
 * @return LTC4260_CONTROL_GPIO_CFG_OUTPUT Output (Set by Alert:GPIO_OUT)
 * @return LTC4260_CONTROL_GPIO_CFG_INPUT Input (Read at STATUS:GPIO_IN)
 */
#define ltc4260_get_control_gpio_cfg(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mControl, LTC4260_CONTROL_GPIO_CFG_FIELD_MASK )


/*******************************************************************************
  Field Setters                                                                              
*******************************************************************************/

/**
 * @brief writes the GPIO_CFG field to the CONTROL register 
 * @param dev ptr to LTC4260 device
 * @option LTC4260_CONTROL_GPIO_CFG_PWR_GOOD Power Good
 * @option LTC4260_CONTROL_GPIO_CFG_PWR_BAD Power Bad
 * @option LTC4260_CONTROL_GPIO_CFG_OUTPUT Output (Set by Alert:GPIO_OUT)
 * @option LTC4260_CONTROL_GPIO_CFG_INPUT Input (Read at STATUS:GPIO_IN)
 */
#define ltc4260_set_control_gpio_cfg(dev, val) regdev_write_field(&(dev)->mRegDev, &(dev)->mControl, LTC4260_CONTROL_GPIO_CFG_FIELD_MASK , (val) )

/*******************************************************************************
  Configs                                                                            
*******************************************************************************/


